Index: /palm/trunk/SOURCE/parin.f90
===================================================================
--- /palm/trunk/SOURCE/parin.f90	(revision 3273)
+++ /palm/trunk/SOURCE/parin.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3248 2018-09-14 09:42:06Z sward
 ! Minor formating changes
 ! 
@@ -420,10 +423,13 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  pt_init, q_init, ref_state, s_init, sa_init,                    &     
+        ONLY:  pt_init, q_init, ref_state, s_init, sa_init,                    &
                ug, u_init, v_init, vg
+
+    USE bulk_cloud_model_mod,                                                  &
+        ONLY:  bcm_parin
 
     USE chemistry_model_mod,                                                   &
         ONLY:  chem_parin
-        
+
     USE chem_modules
 
@@ -455,10 +461,4 @@
     USE land_surface_model_mod,                                                &
         ONLY: lsm_parin
-
-    USE microphysics_mod,                                                      &
-        ONLY:  c_sedimentation, cloud_water_sedimentation,                     &
-               collision_turbulence, curvature_solution_effects_bulk,          &
-               dry_aerosol_radius, limiter_sedimentation, na_init, nc_const,   &
-               sigma_bulk, ventilation_effect
 
     USE model_1d_mod,                                                          &
@@ -525,5 +525,5 @@
     INTEGER(iwp) ::  ioerr          !< error flag for open/read/write
 
-    NAMELIST /inipar/  aerosol_bulk, alpha_surface, approximation, bc_e_b,     &
+    NAMELIST /inipar/  alpha_surface, approximation, bc_e_b,     &
                        bc_lr, bc_ns, bc_p_b, bc_p_t, bc_pt_b, bc_pt_t, bc_q_b, &
              bc_q_t,bc_s_b, bc_s_t, bc_sa_t, bc_uv_b, bc_uv_t,                 &
@@ -531,19 +531,18 @@
              building_length_y, building_wall_left, building_wall_south,       &
              calc_soil_moisture_during_spinup,                                 &
-             call_psolver_at_all_substeps, call_microphysics_at_all_substeps,  &
+             call_psolver_at_all_substeps,  &
              canyon_height,                                                    &
              canyon_width_x, canyon_width_y, canyon_wall_left,                 &
-             canyon_wall_south, c_sedimentation, cfl_factor, cloud_droplets,   &
-             cloud_physics, cloud_scheme, cloud_top_radiation,                 &
-             cloud_water_sedimentation,                                        &
-             collective_wait, collision_turbulence, complex_terrain,           &
+             canyon_wall_south, cfl_factor, cloud_droplets,   &
+             cloud_top_radiation,                 &
+             collective_wait, complex_terrain,           &
              conserve_volume_flow,                                             &
              conserve_volume_flow_mode, constant_flux_layer,                   &
-             coupling_start_time, curvature_solution_effects_bulk,             &
+             coupling_start_time,             &
              cycle_mg, damp_level_1d,                                          &
              data_output_during_spinup,                                        &
              day_of_year_init,                                                 &
              dissipation_1d,                                                   &
-             dp_external, dp_level_b, dp_smooth, dpdxy, dry_aerosol_radius,    &
+             dp_external, dp_level_b, dp_smooth, dpdxy,    &
              dt, dt_pr_1d, dt_run_control_1d, dt_spinup, dx, dy, dz, dz_max,   &
              dz_stretch_factor, dz_stretch_level, dz_stretch_level_start,      &
@@ -555,12 +554,12 @@
              initializing_actions, km_constant,                                &
              large_scale_forcing, large_scale_subsidence, latitude,            &
-             limiter_sedimentation, longitude,                                 &
+             longitude,                                 &
              loop_optimization, lsf_exception, masking_method, mg_cycles,      &
              mg_switch_to_pe0_level, mixing_length_1d, momentum_advec,         &
-             most_method, na_init, nc_const, nesting_offline,                  &
+             most_method, nesting_offline,                  &
              netcdf_precision, neutral, ngsrb,                                 &
              nsor, nsor_ini, nudging, nx, ny, nz, ocean, omega, omega_sor,     &
              outflow_source_plane, passive_scalar,                             &
-             prandtl_number, precipitation, psolver, pt_damping_factor,        &
+             prandtl_number, psolver, pt_damping_factor,        &
              pt_damping_width, pt_reference, pt_surface,                       &
              pt_surface_initial_change, pt_vertical_gradient,                  &
@@ -574,5 +573,5 @@
              roughness_length, sa_surface,                                     &
              sa_vertical_gradient, sa_vertical_gradient_level, scalar_advec,   &
-             scalar_rayleigh_damping, sigma_bulk,                              &
+             scalar_rayleigh_damping,                              &
              spinup_time, spinup_pt_amplitude, spinup_pt_mean,                 &
              statistic_regions, subs_vertical_gradient,                        &
@@ -592,10 +591,10 @@
              use_top_fluxes, use_ug_for_galilei_tr, use_upstream_for_tke,      &
              uv_heights, u_bulk, u_profile, vg_surface, vg_vertical_gradient,  &
-             vg_vertical_gradient_level, v_bulk, v_profile, ventilation_effect,&
+             vg_vertical_gradient_level, v_bulk, v_profile,&
              wall_adjustment, wall_heatflux, wall_humidityflux,                &
              wall_salinityflux, wall_scalarflux, y_shift, zeta_max, zeta_min,  &
              z0h_factor
 
-    NAMELIST /initialization_parameters/  aerosol_bulk, alpha_surface,         &
+    NAMELIST /initialization_parameters/  alpha_surface,         &
              approximation, bc_e_b,                                            &
              bc_lr, bc_ns, bc_p_b, bc_p_t, bc_pt_b, bc_pt_t, bc_q_b,           &
@@ -604,19 +603,18 @@
              building_length_y, building_wall_left, building_wall_south,       &
              calc_soil_moisture_during_spinup,                                 &
-             call_psolver_at_all_substeps, call_microphysics_at_all_substeps,  &
+             call_psolver_at_all_substeps,  &
              canyon_height,                                                    &
              canyon_width_x, canyon_width_y, canyon_wall_left,                 &
-             canyon_wall_south, c_sedimentation, cfl_factor, cloud_droplets,   &
-             cloud_physics, cloud_scheme, cloud_top_radiation,                 &
-             cloud_water_sedimentation,                                        &
-             collective_wait, collision_turbulence, complex_terrain,           &
+             canyon_wall_south, cfl_factor, cloud_droplets,   &
+             cloud_top_radiation,                 &
+             collective_wait, complex_terrain,           &
              conserve_volume_flow,                                             &
              conserve_volume_flow_mode, constant_flux_layer,                   &
-             coupling_start_time, curvature_solution_effects_bulk,             &
+             coupling_start_time,             &
              cycle_mg, damp_level_1d,                                          &
              data_output_during_spinup,                                        &
              day_of_year_init,                                                 &
              dissipation_1d,                                                   &
-             dp_external, dp_level_b, dp_smooth, dpdxy, dry_aerosol_radius,    &
+             dp_external, dp_level_b, dp_smooth, dpdxy,    &
              dt, dt_pr_1d, dt_run_control_1d, dt_spinup, dx, dy, dz, dz_max,   &
              dz_stretch_factor, dz_stretch_level, dz_stretch_level_start,      &
@@ -628,12 +626,12 @@
              initializing_actions, km_constant,                                &
              large_scale_forcing, large_scale_subsidence, latitude,            &
-             limiter_sedimentation, longitude,                                 &
+             longitude,                                 &
              loop_optimization, lsf_exception, masking_method, mg_cycles,      &
              mg_switch_to_pe0_level, mixing_length_1d, momentum_advec,         &
-             most_method, na_init, nc_const, nesting_offline,                  &
+             most_method, nesting_offline,                  &
              netcdf_precision, neutral, ngsrb,                                 &
              nsor, nsor_ini, nudging, nx, ny, nz, ocean, omega, omega_sor,     &
              outflow_source_plane, passive_scalar,                             &
-             prandtl_number, precipitation, psolver, pt_damping_factor,        &
+             prandtl_number, psolver, pt_damping_factor,        &
              pt_damping_width, pt_reference, pt_surface,                       &
              pt_surface_initial_change, pt_vertical_gradient,                  &
@@ -647,5 +645,5 @@
              roughness_length, sa_surface,                                     &
              sa_vertical_gradient, sa_vertical_gradient_level, scalar_advec,   &
-             scalar_rayleigh_damping, sigma_bulk,                              &
+             scalar_rayleigh_damping,                              &
              spinup_time, spinup_pt_amplitude, spinup_pt_mean,                 &
              statistic_regions, subs_vertical_gradient,                        &
@@ -665,5 +663,5 @@
              use_free_convection_scaling,                                      &
              uv_heights, u_bulk, u_profile, vg_surface, vg_vertical_gradient,  &
-             vg_vertical_gradient_level, v_bulk, v_profile, ventilation_effect,&
+             vg_vertical_gradient_level, v_bulk, v_profile,&
              wall_adjustment, wall_heatflux, wall_humidityflux,                &
              wall_salinityflux, wall_scalarflux, y_shift, zeta_max, zeta_min,  &
@@ -684,5 +682,5 @@
              mask_y_loop, mask_z_loop, netcdf_data_format, netcdf_deflate,     &
              normalizing_region, npex, npey, nz_do3d,                          &
-             precipitation_amount_interval, profile_columns, profile_rows,     &
+             profile_columns, profile_rows,     &
              restart_time, section_xy, section_xz, section_yz,                 &
              skip_time_data_output, skip_time_data_output_av, skip_time_dopr,  &
@@ -705,5 +703,5 @@
              mask_y_loop, mask_z_loop, netcdf_data_format, netcdf_deflate,     &
              normalizing_region, npex, npey, nz_do3d,                          &
-             precipitation_amount_interval, profile_columns, profile_rows,     &
+             profile_columns, profile_rows,     &
              restart_time, section_xy, section_xz, section_yz,                 &
              skip_time_data_output, skip_time_data_output_av, skip_time_dopr,  &
@@ -864,4 +862,8 @@
 
 !
+!--       Check if gust module is used and read &gust_par if required
+          CALL bcm_parin
+
+!
 !--       Check if urban surface model is used and read &urban_surface_par if required
           CALL usm_parin
Index: /palm/trunk/SOURCE/plant_canopy_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 3273)
+++ /palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3248 2018-09-14 09:42:06Z sward
 ! Minor formating changes
 ! 
@@ -365,6 +368,8 @@
 
        USE control_parameters,                                                 &
-           ONLY: cloud_physics, coupling_char, message_string,                 &
-                 microphysics_seifert
+           ONLY: coupling_char, message_string
+
+       USE bulk_cloud_model_mod,                                               &
+           ONLY: bulk_cloud_model, microphysics_seifert
 
        USE netcdf_data_input_mod,                                              &
@@ -407,5 +412,5 @@
        ENDIF 
 
-       IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
+       IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
           message_string = 'plant_canopy = .TRUE. requires cloud_scheme /=' // &
                           ' seifert_beheng'
Index: /palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3273)
+++ /palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! unused variables removed
 ! 
@@ -326,8 +329,7 @@
     USE control_parameters,                                                    &
         ONLY:  air_chemistry, bc_dirichlet_l, bc_dirichlet_n, bc_dirichlet_r,  &
-               bc_dirichlet_s, cloud_physics, child_domain,                    &
+               bc_dirichlet_s, child_domain,                                   &
                constant_diffusion, constant_flux_layer,                        &
                coupling_char, dt_3d, dz, humidity, message_string,             &
-               microphysics_morrison, microphysics_seifert,                    &
                neutral, passive_scalar, rans_mode, rans_tke_e,                 &
                roughness_length, simulated_time, topography, volume_flow
@@ -348,4 +350,7 @@
         ONLY:  nbgp, nx, nxl, nxlg, nxlu, nxr, nxrg, ny, nyn, nyng, nys, nysg, &
                nysv, nz, nzb, nzt, wall_flags_0
+
+    USE bulk_cloud_model_mod,                                                  &
+        ONLY: bulk_cloud_model, microphysics_morrison, microphysics_seifert
 
     USE particle_attributes,                                                   &
@@ -1269,10 +1274,10 @@
           CALL pmc_set_dataarray_name( 'coarse', 'q'  ,'fine', 'q',  ierr )
 
-          IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+          IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
             CALL pmc_set_dataarray_name( 'coarse', 'qc'  ,'fine', 'qc',  ierr )  
             CALL pmc_set_dataarray_name( 'coarse', 'nc'  ,'fine', 'nc',  ierr ) 
           ENDIF
 
-          IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
+          IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
              CALL pmc_set_dataarray_name( 'coarse', 'qr'  ,'fine', 'qr',  ierr )
              CALL pmc_set_dataarray_name( 'coarse', 'nr'  ,'fine', 'nr',  ierr ) 
@@ -3842,5 +3847,5 @@
                                       r2yo, r1zo, r2zo, 's' )
 
-          IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+          IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
              CALL pmci_interp_tril_all ( qc, qcc, ico, jco, kco, r1xo, r2xo,   &
                                           r1yo, r2yo, r1zo, r2zo, 's' ) 
@@ -3849,5 +3854,5 @@
           ENDIF
 
-          IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
+          IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
              CALL pmci_interp_tril_all ( qr, qrc, ico, jco, kco, r1xo, r2xo,   &
                                          r1yo, r2yo, r1zo, r2zo, 's' )
@@ -4575,5 +4580,5 @@
                                           nzt_topo_nestbc_l, 'l', 's' )
 
-                IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+                IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
                    CALL pmci_interp_tril_lr( qc, qcc, ico, jco, kco, r1xo,     &
                                              r2xo, r1yo, r2yo, r1zo, r2zo,     &
@@ -4589,5 +4594,5 @@
                 ENDIF
 
-                IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
+                IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
                    CALL pmci_interp_tril_lr( qr, qrc, ico, jco, kco, r1xo,     &
                                              r2xo, r1yo, r2yo, r1zo, r2zo,     &
@@ -4683,5 +4688,5 @@
                                           nzt_topo_nestbc_r, 'r', 's' )
 
-                IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+                IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
 
                    CALL pmci_interp_tril_lr( qc, qcc, ico, jco, kco, r1xo,     &
@@ -4700,5 +4705,5 @@
                 ENDIF
 
-                IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
+                IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
 
      
@@ -4796,5 +4801,5 @@
                                           nzt_topo_nestbc_s, 's', 's' )
 
-                IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+                IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
 
                    CALL pmci_interp_tril_sn( qc, qcc, ico, jco, kco, r1xo,     &
@@ -4812,5 +4817,5 @@
                 ENDIF
 
-                IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
+                IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
 
                    CALL pmci_interp_tril_sn( qr, qrc, ico, jco, kco, r1xo,     &
@@ -4907,5 +4912,5 @@
                                           nzt_topo_nestbc_n, 'n', 's' )
 
-                IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+                IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
 
                    CALL pmci_interp_tril_sn( qc, qcc, ico, jco, kco, r1xo,     &
@@ -4923,5 +4928,5 @@
                 ENDIF
 
-                IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
+                IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
 
                    CALL pmci_interp_tril_sn( qr, qrc, ico, jco, kco, r1xo,     &
@@ -4994,5 +4999,5 @@
                                    r2yo, r1zo, r2zo, 's' )
 
-          IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+          IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
 
              CALL pmci_interp_tril_t( qc, qcc, ico, jco, kco, r1xo, r2xo, r1yo,&
@@ -5004,5 +5009,5 @@
           ENDIF
 
-          IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
+          IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
 
 
@@ -5078,5 +5083,5 @@
                                   kfuo, ijkfc_s, 'q' )
 
-         IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+         IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
 
             CALL pmci_anterp_tophat( qc, qcc, kctu, iflo, ifuo, jflo, jfuo,    &
@@ -5088,5 +5093,5 @@
          ENDIF
 
-         IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
+         IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
 
             CALL pmci_anterp_tophat( qr, qrc, kctu, iflo, ifuo, jflo, jfuo,    &
@@ -5902,5 +5907,5 @@
           ENDDO  
        ENDIF
-       IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+       IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
           DO  m = 1, bc_h(0)%ns
              i = bc_h(0)%i(m)            
@@ -5920,5 +5925,5 @@
        ENDIF
 
-       IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
+       IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
           DO  m = 1, bc_h(0)%ns
              i = bc_h(0)%i(m)            
Index: /palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- /palm/trunk/SOURCE/prognostic_equations.f90	(revision 3273)
+++ /palm/trunk/SOURCE/prognostic_equations.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! omp_get_thread_num now declared in omp directive
 ! 
@@ -289,4 +292,9 @@
                w, w_p
 
+    USE bulk_cloud_model_mod,                                                  &
+        ONLY:  call_microphysics_at_all_substeps, bulk_cloud_model,            &
+               bcm_actions, microphysics_sat_adjust,                           &
+               microphysics_morrison, microphysics_seifert
+
     USE chemistry_model_mod,                                                   &
         ONLY:  chem_integrate, chem_prognostic_equations,                      &
@@ -300,11 +308,11 @@
 
     USE control_parameters,                                                    &
-        ONLY:  air_chemistry, call_microphysics_at_all_substeps,               &
-               cloud_physics, cloud_top_radiation, constant_diffusion,         &
+        ONLY:  air_chemistry,                                                  &
+               cloud_top_radiation, constant_diffusion,                        &
                dp_external, dp_level_ind_b, dp_smooth_factor, dpdxy, dt_3d,    &
                humidity, intermediate_timestep_count,                          &
                intermediate_timestep_count_max, large_scale_forcing,           &
-               large_scale_subsidence, microphysics_morrison,                  &
-               microphysics_seifert, microphysics_sat_adjust, neutral, nudging,&
+               large_scale_subsidence,                  &
+               neutral, nudging, &
                ocean, passive_scalar, plant_canopy,                            &
                prho_reference, prho_reference,                                 &
@@ -381,7 +389,4 @@
     USE lsf_nudging_mod,                                                       &
         ONLY:  ls_advec, nudge
-
-    USE microphysics_mod,                                                      &
-        ONLY:  microphysics_control
 
     USE plant_canopy_model_mod,                                                &
@@ -500,5 +505,5 @@
 !
 !-- If required, calculate cloud microphysics
-    IF ( cloud_physics  .AND.  .NOT. microphysics_sat_adjust  .AND.            &
+    IF ( bulk_cloud_model  .AND.  .NOT. microphysics_sat_adjust  .AND.         &
          ( intermediate_timestep_count == 1  .OR.                              &
            call_microphysics_at_all_substeps ) )                               &
@@ -508,5 +513,5 @@
        DO  i = nxlg, nxrg
           DO  j = nysg, nyng
-             CALL microphysics_control( i, j )
+             CALL bcm_actions( i, j )
            ENDDO
        ENDDO
@@ -995,5 +1000,5 @@
 !--          If required, calculate prognostic equations for cloud water content
 !--          and cloud drop concentration
-             IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+             IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
 !
 !--             Calculate prognostic equation for cloud water content
@@ -1111,5 +1116,5 @@
 !--          If required, calculate prognostic equations for rain water content
 !--          and rain drop concentration
-             IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
+             IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
 !
 !--             Calculate prognostic equation for rain water content
@@ -1371,10 +1376,10 @@
 !
 !-- If required, calculate cloud microphysical impacts
-    IF ( cloud_physics  .AND.  .NOT. microphysics_sat_adjust  .AND.            &
+    IF ( bulk_cloud_model  .AND.  .NOT. microphysics_sat_adjust  .AND.         &
          ( intermediate_timestep_count == 1  .OR.                              &
            call_microphysics_at_all_substeps )                                 &
        )  THEN
        CALL cpu_log( log_point(51), 'microphysics', 'start' )
-       CALL microphysics_control
+       CALL bcm_actions
        CALL cpu_log( log_point(51), 'microphysics', 'stop' )
     ENDIF
@@ -1981,5 +1986,5 @@
 !--    If required, calculate prognostic equations for cloud water content
 !--    and cloud drop concentration
-       IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+       IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
 
           CALL cpu_log( log_point(67), 'qc-equation', 'start' )
@@ -2160,5 +2165,5 @@
 !--    If required, calculate prognostic equations for rain water content
 !--    and rain drop concentration
-       IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
+       IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
 
           CALL cpu_log( log_point(52), 'qr-equation', 'start' )
